=== debian/changelog ===
mongodb (1:1.6.3-1ubuntu2) natty; urgency=low

  * Port to Spidermonkey 1.8.5 (shipped with FF4.0)
    - add debian/patches/mozjs185
    - update debian/patches/series
    - Bump build-depends and depend on xulrunner-2.0-mozjs
    - update debian/xulwrapper

 -- Chris Coulson <chris.coulson@canonical.com>  Thu, 17 Mar 2011 22:45:17 +0000

mongodb (1:1.6.3-1ubuntu1) natty; urgency=low

  * Merge from debian unstable. (LP: #661513) Remaining changes:
    - Providing a wrapper for xulrunner
      - Moves all binaries under /usr/lib/mongodb
      - adds xulwrapper script to mongodb-clients
      - Sets up symlinks to xulwrapper in /usr/bin for all binaries in
        /usr/lib/mongodb
      - Adding dependency on xulrunner-1.9.2 to mongodb-clients as these
        binaries require the library as well.
      - patched buildscripts/hacks_ubuntu.py: removing rpath 
        because wrapper is used 
        - patch renamed to debian/patches/build-process-remove-rpath
      - Removing debian/mongodb-server.lintian -- rpath is no longer used
      - Removing debian/mongodb-clients.lintian -- rpath is no longer used

 -- Clint Byrum <clint@ubuntu.com>  Wed, 20 Oct 2010 09:33:32 -0700

mongodb (1:1.6.3-1) unstable; urgency=low

  * [0ad0c09] Imported Upstream version 1.6.3
    http://jira.mongodb.org/browse/SERVER/fixforversion/10190
  * replica_sets slavedelay, rollback
  * sharding optimization for larger than ram data sets

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Fri, 24 Sep 2010 19:04:25 +0200

mongodb (1:1.6.2-1) unstable; urgency=low

  * [90ef97f] Imported Upstream version 1.6.2
    http://jira.mongodb.org/browse/SERVER/fixforversion/10187

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 02 Sep 2010 17:41:00 +0200

mongodb (1:1.6.1-1) unstable; urgency=low

  * [3b9581e] Imported Upstream version 1.6.1
    http://jira.mongodb.org/browse/SERVER/fixforversion/10183
  * [5866afb] updated watch file fot 1.6.x version

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Wed, 18 Aug 2010 09:33:36 +0200

mongodb (1:1.6.0-1) unstable; urgency=low

  * [7645618] Imported Upstream version 1.6.0
    http://jira.mongodb.org/browse/SERVER/fixforversion/10182
  * [7ae74af] install libs to /usr/lib not /usr/lib64
  * [45c6766] use prefix and smokedbprefix

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Wed, 11 Aug 2010 13:19:25 +0200

mongodb (1:1.4.4-3) unstable; urgency=low

  * [1576744] added libreadline-dev to build-deps (Closes: #589163)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 15 Jul 2010 21:41:49 +0200
