=== debian/changelog ===
mongodb (1:1.8.2-1ubuntu1) oneiric; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Port to Spidermonkey 1.8.5 and use the proper system lib
      - update debian/control to switch build-depend on xulrunner-dev to
        libmozjs185-dev
      - add debian/patches/mozjs185
      - update debian/patches/series
    - Mark mongodb-{server,client,dev} as replacing mongodb to be able to
      upgrade from Lucid
      - update debian/control
    - Drop the binary-or-shlib-defines-rpath lintian overrides. We
      don't need this as we link against a proper system lib
      - remove debian/mongodb-clients.lintian-overrides
      - remove debian/mongodb-server.lintian-overrides
    - Add upstart job:
      - add debian/mongodb-server.mongodb.upstart

  * Drop all the previous diff to launch binaries with LD_LIBRARY_PATH
    and not relying on using rpath
    - remove debian/xulwrapper
    - update debian/mongodb-clients.install
    - update debian/mongodb-server.install
    - update debian/rules
    - update debian/copyright
    - remove debian/patches/build-process-remove-rpath
    - remove debian/patches/series

 -- Chris Coulson <chris.coulson@canonical.com>  Fri, 08 Jul 2011 00:04:13 +0100

mongodb (1:1.8.2-1) unstable; urgency=low

  * New upstream release 1.8.2
    https://jira.mongodb.org/browse/SERVER/fixforversion/10263

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sat, 18 Jun 2011 21:25:25 +0200

mongodb (1:1.8.1-2) unstable; urgency=low

  * Depend on libboost 1.46

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Tue, 31 May 2011 13:19:30 +0200

mongodb (1:1.8.1-1) unstable; urgency=low

  * Upstream 1.8.1
    http://jira.mongodb.org/browse/SERVER/fixforversion/10260

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 07 Apr 2011 07:38:17 +0200

mongodb (1:1.8.0-2) unstable; urgency=low

  * return empty TERM if not set (Closes: #620910)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Tue, 05 Apr 2011 10:21:26 +0200

mongodb (1:1.8.0-1) unstable; urgency=low

  * Upstream 1.8.0
    http://blog.mongodb.org/post/3903149313/mongodb-1-8-released

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 17 Mar 2011 00:10:27 +0100

mongodb (1:1.6.5-3) unstable; urgency=low

  [ Jérémy Lal ]
  * Switch to cdbs, cleanup.
  * Use debian/gbp.conf to filter out debian/* files from upstream tarball.

  [ Antonin Kral ]
  * [ab13e0b] added Vcs-* to debian/control
  * [eb35fc8] added Jeremy as co-maintainer

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 24 Feb 2011 08:36:10 +0100

mongodb (1:1.6.5-2) unstable; urgency=low

  * Clean up Boost packages in Build-Depends
  * Add libboost-dev to mongodb-dev Depends line

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 24 Jan 2011 20:17:29 -0500

mongodb (1:1.6.5-1) unstable; urgency=low

  * Upstream 1.6.5
    http://jira.mongodb.org/browse/SERVER/fixforversion/10207

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Fri, 10 Dec 2010 13:10:04 +0100
