=== debian/control ===
--- 
+++ 
@@ -3,9 +3,11 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
-Uploaders: Roberto C. Sanchez <roberto@connexer.com>
-Build-Depends: debhelper (>= 7), libpcre3, libpcre3-dev, scons, xulrunner-dev (>= 2.0~), libreadline-dev, libboost1.42-dev | libboost1.40-dev | libboost1.35-dev | libboost1.37-dev | libboost1.38-dev, libboost-thread1.42-dev | libboost-thread1.40-dev | libboost-thread1.38-dev | libboost-thread1.37-dev | libboost-thread1.35-dev, libboost-filesystem1.42-dev | libboost-filesystem1.40-dev | libboost-filesystem1.38-dev | libboost-filesystem1.37-dev | libboost-filesystem1.35-dev, libboost-program-options1.42-dev | libboost-program-options1.40-dev | libboost-program-options1.38-dev | libboost-program-options1.37-dev | libboost-program-options1.35-dev, libboost-date-time1.42-dev | libboost-date-time1.40-dev | libboost-date-time1.38-dev | libboost-date-time1.37-dev | libboost-date-time1.35-dev
+Uploaders: Roberto C. Sanchez <roberto@connexer.com>, Jérémy Lal <kapouer@melix.org>
+Build-Depends: debhelper (>= 7), cdbs (>= 0.4.73~), libpcre3, libpcre3-dev, scons, libmozjs185-dev, libreadline-dev, libboost-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-program-options-dev, libboost-date-time-dev, python-pymongo
 Standards-Version: 3.9.1
+Vcs-Git: git://github.com/bobek/mongo-debian.git
+Vcs-Browser: https://github.com/bobek/mongo-debian
 Homepage: http://www.mongodb.org
 
 Package: mongodb
@@ -33,8 +35,7 @@
 
 Package: mongodb-server
 Architecture: i386 amd64
-Depends: mongodb-clients, ${shlibs:Depends}, ${misc:Depends}, adduser,
- xulrunner-2.0-mozjs
+Depends: mongodb-clients, ${shlibs:Depends}, ${misc:Depends}, adduser
 Replaces: mongodb (<= 1:1.4.2-2)
 Description: An object/document-oriented database (server package)
  MongoDB is a high-performance, open source, schema-free 
@@ -58,8 +59,7 @@
 
 Package: mongodb-clients
 Architecture: i386 amd64
-Depends: ${shlibs:Depends}, ${misc:Depends},
- xulrunner-2.0-mozjs
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: mongodb (<= 1:1.4.2-2)
 Description: An object/document-oriented database (client apps)
  MongoDB is a high-performance, open source, schema-free 
@@ -84,7 +84,7 @@
 Package: mongodb-dev
 Section: libdevel
 Architecture: i386 amd64
-Depends: mongodb-server, ${shlibs:Depends}, ${misc:Depends}
+Depends: mongodb-server, libboost-dev, ${shlibs:Depends}, ${misc:Depends}
 Replaces: mongodb (<= 1:1.4.2-2)
 Description: An object/document-oriented database (development)
  MongoDB is a high-performance, open source, schema-free
